#include <windows.h>
#include <stdio.h>

#include "resource.h"

#define xSC_CLOSE -10

#if !defined BELOW_NORMAL_PRIORITY_CLASS
# define BELOW_NORMAL_PRIORITY_CLASS 0x4000
#endif

#if !defined ABOVE_NORMAL_PRIORITY_CLASS
# define ABOVE_NORMAL_PRIORITY_CLASS 0x8000
#endif

void Usage(title,CmdLine)
 char *title,*CmdLine;
 {
  char buf[30*80];

  buf[0]=0;
  if (CmdLine!=NULL) sprintf(buf,"%-2.2s\n\n",CmdLine);
  strcat(buf,
"RUN version 1.04\n\n"
"Usage:\n"
" "
#if defined _CONSOLE
"runc"
#else
"run"
#endif
" [options] file [arguments]\n"
"  Possible options:\n"
"   /?: Usage\n"
"   /o: Open file instead of executing it\n"
"   /e: Edit file instead of executing it\n"
"   /E: Explorer file instead of executing it\n"
"   /p: Print file instead of executing it\n"
"   /P: Show properties of file instead of executing it\n"
"   /S: Silent; do not give message if file can not be executed\n"
"   /w: Wait until file is done\n"
"   /c: Create new console window\n"
"   /H: Hidden\n"
"   /N: Show in normal window\n"
"   /M: Maximized\n"
"   /m: Minimized\n"
"   /f: Give focus to application; use in combination with /M , /m or /N\n"
"   /v: Create separate VDM (NT) (ignored with /o /e /E /p /P options)\n"
"   /s: Create shared VDM (NT) (ignored with /o /e /E /p /P options)\n"
"   /d: Detached; do not create a console window (console applications) (ignored with /o /e /E /p /P options)\n"
"   /h: High priority (ignored with /o /e /E /p /P options)\n"
"   /a: Above normal priority (ignored with /o /e /E /p /P options) (WIN 2000/XP)\n"
"   /b: Below normal priority (ignored with /o /e /E /p /P options) (WIN 2000/XP)\n"
"   /i: Idle (low) priority (ignored with /o /e /E /p /P options)\n"
"   /n: Normal priority (default) (ignored with /o /e /E /p /P options)\n"
"   /r: Realtime priority (ignored with /o /e /E /p /P options)\n"
"   /x[waittime|wcN|wt'wintitle'|wT]: (ignored with /o /e /E /p /P options)\n"
"       Disable Close button after waittime (ms)|window count|window title\n"
"   /Wwaittime: Wait waittime milliseconds before launching the file\n"
       );
# if defined _CONSOLE
   if ((title!=NULL) && (*title))
    printf("%s\n\n",title);
   printf("%s",buf);
# else
   MessageBox(NULL,buf,title,MB_ICONINFORMATION|MB_OK);
# endif
  exit(2);
 }

int SetCloseButton(hWnd,wID)
 HWND hWnd;
 long wID;
 {
  HMENU hMenu;
  long MenuID;
  MENUITEMINFO MII;
  int ret;

  hMenu=GetSystemMenu(hWnd,0);
  if (hMenu) {
   memset(&MII,0,sizeof(MII));
   MII.cbSize=sizeof(MII);
   MII.dwTypeData=NULL;
   MII.cch=0;
   MII.fMask=MIIM_STATE;
   if (wID==xSC_CLOSE)
    MII.wID=SC_CLOSE;
   else
    MII.wID=xSC_CLOSE;

   ret=GetMenuItemInfo(hMenu,MII.wID,FALSE,&MII);
   if (ret) {
    MenuID=MII.wID;
    MII.wID=wID;
    MII.fMask=MIIM_ID+MIIM_STATE;
    if (wID==xSC_CLOSE)
     MII.fState=MFS_GRAYED;
    else
     MII.fState=MFS_ENABLED;
    ret=SetMenuItemInfo(hMenu,MenuID,FALSE,&MII);
    if (ret)
     ret=SendMessage(hWnd,WM_NCACTIVATE,TRUE,0);
   }
  }
  return(ret);
 }

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
 {
  int ret,wait=FALSE,focus=FALSE,closebutton=TRUE,WaitClose=0,Silent=FALSE,n,WindowNameLen=0,WaitNonEmptyWindow=FALSE,WaitTime=0;
  DWORD CreationFlags;
  char *CurrentDirectory,*CmdLine,*ptr1,*ptr2,*WindowName=NULL,*Action=NULL;
  STARTUPINFO StartupInfo;
  PROCESS_INFORMATION ProcessInformation;
  HWND hWnd;
  DWORD dwProcessId,dwProcessId1;
  HANDLE hProcess;
  SHELLEXECUTEINFO ShExecInfo;

  CreationFlags=0;
  CurrentDirectory=NULL;

  memset(&StartupInfo,0,sizeof(StartupInfo));
  memset(&ProcessInformation,0,sizeof(ProcessInformation));
  StartupInfo.cb=sizeof(StartupInfo);
  StartupInfo.lpReserved=NULL;
  StartupInfo.dwFlags=STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow=SW_SHOWNORMAL;

  memset(&ShExecInfo,0,sizeof(ShExecInfo));
  ShExecInfo.cbSize=sizeof(SHELLEXECUTEINFO);
  ShExecInfo.fMask=SEE_MASK_FLAG_DDEWAIT|SEE_MASK_NOCLOSEPROCESS;

  CmdLine=lpCmdLine;
  do {
   while ((*CmdLine) && (isspace(*CmdLine))) CmdLine++;
   if (*CmdLine) {
    if (*CmdLine!='/') break;
    CmdLine++;
   }
   switch (*CmdLine) {
    case 'o': /* Use ShellExecute to open file in stead of CreateProcess */
     Action="Open";
     break;
    case 'e': /* Use ShellExecute to edit file in stead of CreateProcess */
     Action="Edit";
     break;
    case 'E': /* Use ShellExecute to explorer file in stead of CreateProcess */
     Action="Explore";
     break;
    case 'p': /* Use ShellExecute to print file in stead of CreateProcess */
     Action="Print";
     break;
    case 'P': /* Use ShellExecute to show properties of file in stead of CreateProcess */
     Action="Properties";
     break;
    case 'c': /* create new console window */
     CreationFlags|=CREATE_NEW_CONSOLE;
     ShExecInfo.fMask|=SEE_MASK_NO_CONSOLE;
     break;
    case 'w': /* wait until file is done */
     wait=TRUE;
     break;
    case 'v': /* create separate VDM  (NT)*/
     CreationFlags|=CREATE_SEPARATE_WOW_VDM;
     break;
    case 's': /* create shared VDM (NT) */
     CreationFlags|=CREATE_SHARED_WOW_VDM;
     break;
    case 'd': /* Do not create a console */
     CreationFlags|=DETACHED_PROCESS;
     break;
    case 'h': /* run in high priority */
     CreationFlags|=HIGH_PRIORITY_CLASS;
     break;
    case 'a': /* run in above normal priority but below high priority */
     CreationFlags|=ABOVE_NORMAL_PRIORITY_CLASS;
     break;
    case 'b': /* run in below normal priority but above idle priority */
     CreationFlags|=BELOW_NORMAL_PRIORITY_CLASS;
     break;
    case 'i': /* run in idle (low) priority */
     CreationFlags|=IDLE_PRIORITY_CLASS;
     break;
    case 'n': /* run in normal priority */
     CreationFlags|=NORMAL_PRIORITY_CLASS;
     break;
    case 'r': /* realtime priority */
     CreationFlags|=REALTIME_PRIORITY_CLASS;
     break;
    case 'N': /* show in normal window */
     StartupInfo.wShowWindow=SW_SHOWNOACTIVATE;
     break;
    case 'H': /* hidden */
     StartupInfo.wShowWindow=SW_HIDE;
     break;
    case 'M': /* Maximized */
     StartupInfo.wShowWindow=SW_MAXIMIZE;
     break;
    case 'm': /* Minimized */
     StartupInfo.wShowWindow=SW_MINIMIZE;
     break;
    case 'f': /* give focus */
     focus=TRUE;
     break;
    case 'x': /* disable close */
     closebutton=FALSE;
     if (isdigit(CmdLine[1])) {
      WaitClose=strtol(CmdLine+1,&CmdLine,10);
      CmdLine--;
     }
     else if ((CmdLine[1]=='w') && (CmdLine[2]=='c')) {
      WaitClose=-strtol(CmdLine+3,&CmdLine,10);
      CmdLine--;
     }
     else if ((CmdLine[1]=='w') && (CmdLine[2]=='t')) {
      ptr1=CmdLine+3;
      while (isspace(*ptr1)) ptr1++;
      if (*ptr1!='\'') Usage("Illegal argument",CmdLine-1);
      ptr2=++ptr1;
      while ((*ptr2) && ((ptr2[0]!='\'') || (ptr2[1]=='\''))) ptr2++;
      if (*ptr2!='\'') Usage("Illegal argument",CmdLine-1);
      WindowName=ptr1;
      WindowNameLen=(int) (ptr2-ptr1);
      CmdLine=ptr2;
     }
     else if ((CmdLine[1]=='w') && (CmdLine[2]=='T')) {
      WaitNonEmptyWindow=TRUE;
      CmdLine+=2;
     }
     break;
    case 'W': /* Wait some time before to launch file */
     WaitTime=strtol(CmdLine+1,&CmdLine,10);
     break;
    case 'S': /* silent */
     Silent=TRUE;
     break;
    case '?': /* help */
     Usage("",NULL);
    default:
     Usage("Illegal argument",*CmdLine ? CmdLine-1 : "");
     break;
   }
   CmdLine++;
  } while (TRUE);

  if (WaitTime>0)
   Sleep(WaitTime);

  if (focus)
   switch (StartupInfo.wShowWindow) {
    case SW_MAXIMIZE:
     StartupInfo.wShowWindow=SW_SHOWMAXIMIZED;
     break;
    case SW_MINIMIZE:
     StartupInfo.wShowWindow=SW_SHOWMINIMIZED;
     break;
    case SW_SHOWNOACTIVATE:
     StartupInfo.wShowWindow=SW_SHOWNORMAL;
     break;
   }

  ShExecInfo.hwnd=NULL;
  ShExecInfo.lpVerb=Action;
  ShExecInfo.lpFile=CmdLine;
  ShExecInfo.lpParameters=NULL;
  ShExecInfo.lpDirectory=CurrentDirectory;
  ShExecInfo.nShow=StartupInfo.wShowWindow;
  ShExecInfo.hInstApp=hInstance;
  if (Silent)
   ShExecInfo.fMask|=SEE_MASK_FLAG_NO_UI;

  if (Action==NULL) {
   ret=CreateProcess(NULL,CmdLine,NULL,NULL,FALSE,CreationFlags,NULL,CurrentDirectory,&StartupInfo,&ProcessInformation);
   hProcess=ProcessInformation.hProcess;
   dwProcessId=ProcessInformation.dwProcessId;
  }
  else {
   ret=ShellExecuteEx(&ShExecInfo);
   hProcess=ShExecInfo.hProcess;
   dwProcessId=0;
  }

  if (ret) {
   if (hProcess) {
    if ((!closebutton) && (dwProcessId)) {
     if (WaitClose>0)
      Sleep(WaitClose);
     n=0;
     do {
      if (n)
       Sleep(500);
      n=0;
      hWnd=GetTopWindow(0);
      while (hWnd!=0) {
       GetWindowThreadProcessId(hWnd,&dwProcessId1);
       if (dwProcessId1==dwProcessId) {
	if ((WindowName!=NULL) || (WaitNonEmptyWindow)) {
	 char winTitle[256];

	 GetWindowText(hWnd,winTitle,sizeof(winTitle));
	 if (WaitNonEmptyWindow) {
	  if (*winTitle==0)
	   dwProcessId1=0;
	 }
	 else
	  if (strnicmp(winTitle,WindowName,WindowNameLen))
	   dwProcessId1=0;
	}
	if (dwProcessId1==dwProcessId) {
	 SetCloseButton(hWnd,xSC_CLOSE);
	 if ((WindowName!=NULL) || (WaitNonEmptyWindow)) {
 	  WindowName=NULL;
	  WaitNonEmptyWindow=FALSE;
	  break;
	 }
	}
	n++;
       }
       hWnd=GetWindow(hWnd,GW_HWNDNEXT);
      }
      n=1;
     } while ((((WaitClose<0) && (n<-WaitClose)) || (WindowName!=NULL) || (WaitNonEmptyWindow)) && (WaitForSingleObject(hProcess,0)!=WAIT_OBJECT_0));
    }

    if (wait) WaitForSingleObject(hProcess,INFINITE);

    CloseHandle(hProcess);
   }
  }
  else if ((!Silent) && (Action==NULL))
   MessageBox(NULL,CmdLine,"Unable to execute file",MB_ICONSTOP|MB_OK);

  return(ret ? 0 : 1);
 }

#if defined _CONSOLE
 int main(int argc, char **argv)
 {
  LPSTR lpCmdLine;
  char InQuote=FALSE;

  lpCmdLine=GetCommandLine();
  while (isspace(*lpCmdLine))
   lpCmdLine++;
  while ((*lpCmdLine) && ((InQuote) || (!isspace(*lpCmdLine))))
   if ((*(lpCmdLine++))=='"')
    InQuote=!InQuote;
  while (isspace(*lpCmdLine))
   lpCmdLine++;

  return(WinMain(0,NULL,lpCmdLine,SW_SHOW));
 }
#endif
